stages:
  - infra_validate
  - infra_plan
  - infra_apply
  - build
  - test
  - release
  - deploy_validate
  - deploy_plan
  - deploy_apply
  - deploy_ansible

variables:
  VERSION: ${CI_COMMIT_REF_SLUG}-${CI_COMMIT_SHORT_SHA}
  TF_VAR_environment: default
  TF_VAR_USER: ${GITLAB_USER_NAME}
  TF_VAR_COMMIT: ${CI_COMMIT_SHORT_SHA}
  TF_VAR_BRANCH: ${CI_COMMIT_BRANCH}
  TFDIR: terraform
  TF_INPUT: 0 # All inputs are disabled on CI environment
  AWS_DEFAULT_REGION: us-east-1
  ECR_REPO: 605776579979.dkr.ecr.us-east-1.amazonaws.com
  DOCKER_HOST: tcp://docker:2375
  DOCKER_DRIVER: overlay2
  DOCKER_TLS_CERTDIR: ""

image:
  name: hashicorp/terraform:light
  entrypoint:
    - '/usr/bin/env'
    - 'PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin'

before_script:
  - export AWS_ACCESS_KEY=${AWS_ACCESS_KEY_ID}
  - export AWS_SECRET_ACCESS_KEY=${AWS_SECRET_ACCESS_KEY}
  - export AWS_SESSION_TOKEN=${AWS_SESSION_TOKEN}
  - cd ${TFDIR}/infra/
  - rm -rf .terraform
  - terraform --version
  - terraform init

infra-validate:
  stage: infra_validate
  script:
    - terraform validate

infra-plan:
  stage: infra_plan
  script:
    - terraform plan -out=${PLAN}
  dependencies:
    - infra-validate
  artifacts:
    paths:
      - ${TFDIR}/infra/${PLAN}

infra-apply:
  stage: infra_apply
  script:
    - terraform apply ${PLAN}
  environment:
    name: ${TF_VAR_environment}
  allow_failure: false
  dependencies:
    - infra-plan
  when: manual
